(define (add1 x)
  (+ x 1))

(define (sub1 x)
  (- x 1))

(define (status? vect x y)
  (if (or (< x 0) (< y 0) (> x (sub1 WIDTH)) (> y (sub1 HEIGHT)))
      #f
      (vector-ref (vector-ref vect x) y)))

(define (status! vect x y new-state)
  (if (or (< x 0) (< y 0) (> x (sub1 WIDTH)) (> y (sub1 HEIGHT)))
      (error "status! y a un truc ki va pa!" vect x y)
      (vector-set! (vector-ref vect x) y new-state)))

(define (bombed? x y type)
  (and (> x -1) (> y -1) (< x WIDTH) (< y HEIGHT) (eq? (status? coulee x y) type)))

(define (test-coulee x y type)
  (case (- type 5)
    ((1) #t)
    ((2) (or (bombed? x (sub1 y) type) (bombed? (add1 x) y type) (bombed? (sub1 x) y type) (bombed? x (add1 y) type)))
    ((3) (or (and (bombed? x (- y 2) type) (bombed? x (sub1 y) type))
             (and (bombed? (add1 x) y type) (bombed? (+ x 2) y type))
             (and (bombed? (sub1 x) y type) (bombed? (- x 2) y type))
             (and (bombed? x (add1 y) type) (bombed? x (+ y 2) type))
             (and (bombed? (sub1 x) y type) (bombed? (add1 x) y type))
             (and (bombed? x (sub1 y) type) (bombed? x (add1 y) type))))
    
    ((4) (or (and (bombed? x (- y 2) type) (bombed? x (sub1 y) type)(bombed? x (- y 3) type))
             (and (bombed? (add1 x) y type) (bombed? (+ x 2) y type)(bombed? (+ x 3) y type))
             (and (bombed? (sub1 x) y type) (bombed? (- x 2) y type)(bombed? (- x 3) y type))
             (and (bombed? x (+ y 2) type) (bombed? x (add1 y) type)(bombed? x (+ y 3) type))
             (and (bombed? (sub1 x) y type) (bombed? (add1 x) y type)(bombed? (+ x 2) y type))
             (and (bombed? (- x 2) y type) (bombed? (sub1 x) y type)(bombed? (add1 x) y type))
             (and (bombed? x (- y 2) type) (bombed? x (sub1 y) type)(bombed? x (add1 y) type))
             (and (bombed? x (+ y 2) type) (bombed? x (sub1 y) type)(bombed? x (add1 y) type))))
    
    ((5) (or (and (bombed? x (- y 2) type) (bombed? x (sub1 y) type)(bombed? x (- y 4) type)(bombed? x (- y 3) type))
             (and (bombed? (add1 x) y type) (bombed? (+ x 2) y type)(bombed? (+ x 3) y type)(bombed? (+ x 4) y type))
             (and (bombed? x (+ y 2) type) (bombed? x (add1 y) type)(bombed? x (+ y 3) type)(bombed? x (+ y 4) type))
             (and (bombed? (sub1 x) y type) (bombed? (- x 2) y type)(bombed? (- x 3) y type)(bombed? (- x 4) y type))
             (and (bombed? (sub1 x) y type) (bombed? (- x 2) y type)(bombed? (- x 3) y type)(bombed? (+ x 1) y type))
             (and (bombed? (sub1 x) y type) (bombed? (- x 2) y type)(bombed? (+ x 2) y type)(bombed? (add1 x) y type))
             (and (bombed? (sub1 x) y type) (bombed? (+ x 3) y type)(bombed? (+ x 2) y type)(bombed? (add1 x) y type))
             (and (bombed? x (- y 2) type) (bombed? x (sub1 y) type)(bombed? x (- y 3) type)(bombed? x (add1 y) type))
             (and (bombed? x (- y 2) type) (bombed? x (sub1 y) type)(bombed? x (+ y 2) type)(bombed? x (add1 y) type))
             (and (bombed? x (+ y 2) type) (bombed? x (sub1 y) type)(bombed? x (add1 y) type)(bombed? x (+ y 3) type))))))
    
(define (a-ajouter x y n)
  (if (test-coulee x y n)
      (if (and (= game-type 2) (> request-t 0))
      (set! request-t (+ 5 request-t))
      (begin
      (send message set-label (string-append "Ship Type " (number->string (- n 5)) " is Down"))
      (sleep 1)
      (case (- n 5)
        ((1) (play-sound "alert.wav" #f))
        ((2) (play-sound "alert.wav" #f)(play-sound "alert.wav" #f))
        ((3) (play-sound "alert.wav" #f)(play-sound "alert.wav" #f)(play-sound "alert.wav" #f))
        ((4) (play-sound "alert.wav" #f)(play-sound "alert.wav" #f)
         (play-sound "alert.wav" #f)(play-sound "alert.wav" #f))
        ((5) (play-sound "alert.wav" #f)(play-sound "alert.wav" #f)(play-sound "alert.wav" #f)
         (play-sound "alert.wav" #f)(play-sound "alert.wav" #f)))
      (play-sound "error.wav" #f)))))
      
(define (insert-hasard vect nb type)
  (define (inter-hasard i)
    (if (= i nb)
          (send message set-label (string-append "insert-hasard -- " (number->string nb) " -- type -- DONE"))
        (let ((x (inexact->exact (random WIDTH)))(y (inexact->exact (random HEIGHT)))
              (h (inexact->exact (random 2)))(nb-pose type))
          (if (and (< h 0.5)
               (can-pose? vect x y nb-pose 'v))
          (begin
            (pose! vect x y nb-pose 'v)
            (send message set-label (string-append "insert-hasard -- " (number->string nb) " -- type -- OK"))
            (inter-hasard (add1 i)))
          (if (and (> h 0.5)
                   (can-pose? vect x y nb-pose 'h))
              (begin 
                (pose! vect x y nb-pose 'h)
                (inter-hasard (add1 i)))
              (begin
                (send message set-label 
                      (string-append "on reessaie -- hasard " (number->string nb) " -- " (number->string i) 
                                     " -- " (number->string x) " --" (number->string y) " -- " (number->string h)))
                (inter-hasard i)))))))
  (inter-hasard 0))
         
(define (fill-rest vect)
  (do ((i 0 (add1 i)))
    ((= i WIDTH))
    (do ((j 0 (add1 j)))
      ((= j HEIGHT))
      (if (eq? (status? vect i j) 'not-set)
          (status! vect i j 'empty)))))

(define (init pasteboard is)
  (do ((j 0 (add1 j)))
    ((= j HEIGHT) )
    (do ((i 0 (add1 i)))
      ((= i WIDTH) )
      (send pasteboard insert (make-object image-snip% is) (* IMG-SIZE i) (* IMG-SIZE j)))))

(define (for-each vect msg)
  (do ((j 0 (add1 j)))
    ((= j HEIGHT) )
    (do ((i 0 (add1 i)))
      ((= i WIDTH) )
      (status! vect i j msg))))

(define (not-set? vect x y)
  (and (eq? (status? vect x y) 'not-set)
       (status? vect x y)
       #t))

(define (can-pose? vect x y nb-2-pose direction)
  (let* ((h? (eq? direction 'h))(v? (not h?))
         (i1 (if h? 1 0))(i2 (if h? 2 0))(i3 (if h? 3 0))(i4 (if h? 4 0))
         (j1 (if v? 1 0))(j2 (if v? 2 0))(j3 (if v? 3 0))(j4 (if v? 4 0)))
      (case nb-2-pose
        ((1) (not-set? vect x y))
        ((2) (and (not-set? vect x y) (not-set? vect (+ x i1) (+ y j1))))
        ((3) (and (not-set? vect x y) (not-set? vect (+ x i1) (+ y j1)) (not-set? vect (+ x i2) (+ y j2))))
        ((4) (and (not-set? vect x y) (not-set? vect (+ x i1) (+ y j1)) (not-set? vect (+ x i2) (+ y j2)) 
                  (not-set? vect (+ x i3) (+ y j3))))
        ((5) (and (not-set? vect x y) (not-set? vect (+ x i1) (+ y j1)) (not-set? vect (+ x i2) (+ y j2)) 
                  (not-set? vect (+ x i3) (+ y j3)) (not-set? vect (+ x i4) (+ y j4)))))))

(define (pose-one! vect x y nb-2-pose)
  (case nb-2-pose
      ((1) (status! vect x y 'type-1)(status! coulee x y 1))
      ((2) (status! vect x y 'type-2)(status! coulee x y 2))
      ((3) (status! vect x y 'type-3)(status! coulee x y 3))
      ((4) (status! vect x y 'type-4)(status! coulee x y 4))
      ((5) (status! vect x y 'type-5)(status! coulee x y 5))))

(define (pose-one2! vect x y nb-2-pose)
  (case nb-2-pose
      ((1) (status! vect x y 'type-1)(status! coulee1 x y 1))
      ((2) (status! vect x y 'type-2)(status! coulee1 x y 2))
      ((3) (status! vect x y 'type-3)(status! coulee1 x y 3))
      ((4) (status! vect x y 'type-4)(status! coulee1 x y 4))
      ((5) (status! vect x y 'type-5)(status! coulee1 x y 5))))

(define (pose! vect x y nb-2-pose direction)
  (let* ((h? (eq? direction 'h))(v? (not h?))
         (i1 (if h? 1 0))(i2 (if h? 2 0))(i3 (if h? 3 0))(i4 (if h? 4 0))
         (j1 (if v? 1 0))(j2 (if v? 2 0))(j3 (if v? 3 0))(j4 (if v? 4 0)))
        (begin
          (case nb-2-pose
        ((1) (pose-one! vect x y 1))
        ((2) (pose-one! vect x y 2)(pose-one! vect (+ x i1) (+ y j1) 2))
        ((3) (pose-one! vect x y 3)(pose-one! vect (+ x i1) (+ y j1) 3)
         (pose-one! vect (+ x i2) (+ y j2) 3))
        ((4) (pose-one! vect x y 4)(pose-one! vect (+ x i1) (+ y j1) 4)
         (pose-one! vect (+ x i2) (+ y j2) 4)(pose-one! vect (+ x i3) (+ y j3) 4))
        ((5) (pose-one! vect x y 5)(pose-one! vect (+ x i1) (+ y j1) 5)
         (pose-one! vect (+ x i2) (+ y j2) 5)(pose-one! vect (+ x i3) (+ y j3) 5)
         (pose-one! vect (+ x i4) (+ y j4) 5)))
        (send message set-label (string-append (number->string x) "--" (number->string y) "--"
                                               (number->string nb-2-pose) "-- h/v i: " (number->string i1) "-- OK")))))

(define (pose2! vect x y nb-2-pose direction)
  (let* ((h? (eq? direction 'h))(v? (not h?))
         (i1 (if h? 1 0))(i2 (if h? 2 0))(i3 (if h? 3 0))(i4 (if h? 4 0))
         (j1 (if v? 1 0))(j2 (if v? 2 0))(j3 (if v? 3 0))(j4 (if v? 4 0)))
        (begin
          (case nb-2-pose
        ((1) (pose-one2! vect x y 1))
        ((2) (pose-one2! vect x y 2)(pose-one2! vect (+ x i1) (+ y j1) 2))
        ((3) (pose-one2! vect x y 3)(pose-one2! vect (+ x i1) (+ y j1) 3)
         (pose-one2! vect (+ x i2) (+ y j2) 3))
        ((4) (pose-one2! vect x y 4)(pose-one2! vect (+ x i1) (+ y j1) 4)
         (pose-one2! vect (+ x i2) (+ y j2) 4)(pose-one2! vect (+ x i3) (+ y j3) 4))
        ((5) (pose-one2! vect x y 5)(pose-one2! vect (+ x i1) (+ y j1) 5)
         (pose-one2! vect (+ x i2) (+ y j2) 5)(pose-one2! vect (+ x i3) (+ y j3) 5)
         (pose-one2! vect (+ x i4) (+ y j4) 5)))
        (send message set-label (string-append (number->string x) "--" (number->string y) "--"
                                               (number->string nb-2-pose) "-- h/v i: " (number->string i1) "-- OK")))))

(define (show! vect x y nb-2-pose direction)
  (let* ((h? (eq? direction 'h))(v? (not h?))
         (i1 (if h? IMG-SIZE 0))(i2 (if h? (* 2 IMG-SIZE) 0))(i3 (if h? (* 3 IMG-SIZE) 0))(i4 (if h? (* 4 IMG-SIZE) 0))
         (j1 (if v? IMG-SIZE 0))(j2 (if v? (* 2 IMG-SIZE) 0))(j3 (if v? (* 3 IMG-SIZE) 0))(j4 (if v? (* 4 IMG-SIZE) 0))
         (x0 (* x IMG-SIZE))(y0 (* y IMG-SIZE))
         (is1 (send my-pasteboard find-snip x0 y0))
         (is2 (send my-pasteboard find-snip (+ x0 i1) (+ y0 j1)))
         (is3 (send my-pasteboard find-snip (+ x0 i2) (+ y0 j2)))
         (is4 (send my-pasteboard find-snip (+ x0 i3) (+ y0 j3)))
         (is5 (send my-pasteboard find-snip (+ x0 i4 )(+ y0 j4))))
        (case nb-2-pose
          ((1) (send is1 set-bitmap type-1-is))
          ((2) (send is1 set-bitmap type-2-is)(send is2 set-bitmap type-2-is))
          ((3) (send is1 set-bitmap type-3-is)(send is2 set-bitmap type-3-is)(send is3 set-bitmap type-3-is))
          ((4) (send is1 set-bitmap type-4-is)(send is2 set-bitmap type-4-is)
           (send is3 set-bitmap type-4-is)(send is4 set-bitmap type-4-is))
          ((5) (send is1 set-bitmap type-5-is)(send is2 set-bitmap type-5-is)(send is3 set-bitmap type-5-is)
           (send is4 set-bitmap type-5-is)(send is5 set-bitmap type-5-is)))))

(define (pose-and-show! vect x y nb-to-pose direction)
  (pose! vect x y nb-to-pose direction)
  (show! vect x y nb-to-pose direction))
    
(define (pose-and-show2! vect x y nb-to-pose direction)
  (pose2! vect x y nb-to-pose direction)
  (show! vect x y nb-to-pose direction))

 (define (show-all-ships my-or-his)
   (do ((i 0 (add1 i)))
     ((= i WIDTH) )
     (do ((j 0 (add1 j)))
       ((= j HEIGHT))
       (reveal i j my-or-his))))

 (define (print-grid vect)
   (do ((i 0 (add1 i)))
     ((= i WIDTH) )
     (do ((j 0 (add1 j)))
       ((= j HEIGHT))
       (printf "~a ~a : ~a~n" i j (status? vect i j)))))
 
 (define (reveal i j his-or-my)
   (let ((s (send (if (eq? his-or-my 'his) 
                      his-pasteboard
                      my-pasteboard) find-snip (* i IMG-SIZE) (* j IMG-SIZE))))
     (case (status? (if (eq? his-or-my 'his)
                        his-grid-vect 
                        my-grid-vect) i j)
       ((checked) ())
       ((empty) (send s set-bitmap  empty-is))
       ((type-1) (send s set-bitmap type-1-is))
       ((type-2) (send s set-bitmap type-2-is))
       ((type-3) (send s set-bitmap type-3-is))
       ((type-4) (send s set-bitmap type-4-is))
       ((type-5) (send s set-bitmap type-5-is)) 
       (else (display "IMPOSSIBLE SIR !")))))
 
(define (test-end-of-game)
  (if (= nb-bombs i-bombed)
      (begin
        (set! end-of-game? #t)
        (set! winner 'home))
      (if (= nb-bombs he-bombed)
          (begin
            (set! end-of-game? #t)
            (set! winner 'away)))))

(define (end-of-game-greeting)
  (define bye-bye-frame (make-object frame% "Bye Bye !"))
  (let ((msg '?))
    (if (eq? winner 'home)
      (set! msg "Congratz , You Won !")
      (set! msg "Hard Luck , You Lost !"))
    (play-sound "alarm.wav" #f)
    (if (eq? game-type 1)
        (begin
          (show-all-ships 'his)
          (send message set-label "5 SEC. TO SEE WHERE THE SHIPS WERE")
          (sleep 2)))
    (send bye-bye-frame show #t)
    (send super-frame show #f)
    (make-object message% msg bye-bye-frame)
    (make-object message% "" bye-bye-frame)
    (make-object message% "Good Bye ! Have a Nice Day !" bye-bye-frame)
    (make-object button% "Quit" bye-bye-frame (lambda(bon ben) (send bye-bye-frame show #f)))))

(define (end-of-game-greeting-net)
  (define bye-bye-frame (make-object frame% "Bye Bye !"))
  (let ((msg '?))
    (if (eq? winner 'home)
      (set! msg "Congratz , You Won !")
      (set! msg "Hard Luck , You Lost !"))
    (play-sound "alarm.wav" #f)
    (send bye-bye-frame show #t)
    (send super-frame show #f)
    (make-object message% msg bye-bye-frame)
    (make-object message% "" bye-bye-frame)
    (make-object message% "Good Bye ! Have a Nice Day !" bye-bye-frame)
    (make-object button% "Quit" bye-bye-frame (lambda(bon ben) (send bye-bye-frame show #f)))))

(define (end-of-time-greeting)
  (define bye-bye-frame (make-object frame% "Bye Bye !"))
  (let ((msg '?))
    (set! msg "End Of Time error : game over !")
    (play-sound "alarm.wav" #f)
    (send bye-bye-frame show #t)
    (send super-frame show #f)
    (make-object message% msg bye-bye-frame)
    (make-object message% "" bye-bye-frame)
    (make-object message% "Good Bye ! Have a Nice Day !" bye-bye-frame)
    (make-object button% "Quit" bye-bye-frame (lambda(bon ben) (send bye-bye-frame show #f)))))

(define (insert-ships my-or-his)
  (do ((i 1 (add1 i)))
    ((= i (vector-length ships-vect)) )
    (insert-hasard (if (eq? my-or-his 'his)
                       his-grid-vect
                       coulee) (vector-ref ships-vect i) i)))

(define (test-nb-posed)
  (if (= nb-posed nb-bombs)
      (let ((flag #t))
        (do ((i 1 (add1 i)))
          ((= i (vector-length ships-vect)) )
          (set! flag (and flag (= (vector-ref ships-vect i) (vector-ref nb-posed-type i)))))
        (if flag
            (begin
              (set! game-started? #t)
              (fill-rest my-grid-vect)
              (send message set-label "End of Init ! Shall The Game Start !"))
            (begin
              (send message set-label "Init Again Accordgin to the nb You choosed !")
              (reset))))))

(define (analyse-move move)
  (let ((t-match (regexp-match "t[0-9f]+t" move))
        (x-match (regexp-match "x[0-9]+x" move))
        (y-match (regexp-match "y[0-9]+y" move))) 
    (list (string->number (car (regexp-match "[0-9f]+" (car t-match))))
          (string->number (car (regexp-match "[0-9]+" (car x-match)))) 
          (string->number (car (regexp-match "[0-9]+" (car y-match)))))))

(define (generate-move-0)
  (let ((x (inexact->exact (random WIDTH)))(y (inexact->exact (random HEIGHT))))
    (if (eq? (status? my-grid-vect x y) 'checked)
        (generate-move-0)
        (string-append "t0tx" (number->string x) "xy" (number->string y) "y"))))

(define (generate-move-1 mv)
  (if (null? mv)
      (generate-move)
      (if (and (null? (cdr mv)) last-forced? )
          (begin
            (set! last-forced? #f)
            (set! force-move (cons (car mv) (cons last-bomb '())))
            (generate-move-1 force-move))
          (let ((now-what (car mv)))
            (if (can-click? (car now-what) (cdr now-what))
                (string-append "t0tx" (number->string (car now-what)) "xy" (number->string (cdr now-what)) "y")
                (begin
                  (set! force-move (cdr force-move))
                  (generate-move-1 force-move)))))))


(define (generate-move-3 mv)
  (if (null? mv)
      (generate-move)
      (let* ((x (car mv))(y (cdr mv)))
            (if (can-click? x y)
                  (begin
                    (if (member (status? my-grid-vect x y) '(type-1 type-2 type-3 type-4))
                          (case way
                            ((right) (set! force-move (cons (add1 x) y)) (set! way 'right))
                            ((up) (set! force-move (cons x (sub1 y))) (set! way 'up))
                            ((left) (set! force-move (cons (sub1 x) y)) (set! way 'left))
                            ((down) (set! force-move (cons x (add1 y))) (set! way 'down)))
                          (if (eq? (status? my-grid-vect x y) 'empty)
                                (case way
                                  ((right) (set! way 'left)(set! force-move (cons (sub1 x) y)))
                                  ((up) (set! way 'down)(set! force-move (cons x (add1 y))))
                                  ((left) (set! way 'right)(set! force-move (cons (add1 x) y)))
                                  ((down) (set! way 'up)(set! force-move (cons x (sub1 y)))))
                              (case way
                                  ((right) (generate-move-2 (cons (sub1 x) y)))
                                  ((up) (generate-move-2 (cons x (add1 y))))
                                  ((left) (generate-move-2 (cons (add1 x) y)))
                                  ((down) (generate-move-2 (cons x (sub1 y)))))))
                    (string-append "t0tx" (number->string x) "xy" (number->string y) "y"))
                  (if (or (eq? (status? my-grid-vect x y) 'checked)
                          (eq? (status? my-grid-vect x y) 'checked)
                          (eq? (status? my-grid-vect x y) 'checked)
                          (eq? (status? my-grid-vect x y) 'checked))
                      (case way
                        ((right) (set! way 'left)(generate-move-2 (cons (sub1 x) y)))
                        ((up) (set! way 'left)(generate-move-2 (cons x (add1 y))))
                        ((left) (set! way 'left)(generate-move-2 (cons (add1 x) y)))
                        ((down) (set! way 'left)(generate-move-2 (cons x (sub1 y)))))
                      (begin
                    (set! force-move '())
                    (generate-move)))))))

(define (generate-move-2 mv)
  (if (null? mv)
      (generate-move)
      (if (null? (car mv))
          (begin
            (set! force-move (cdr force-move))
            (generate-move-2 force-move))
      (let* ((block (car mv))(x (car block))(y (cdr block)))
            (begin
              (set! force-move (cdr force-move))
              (if (can-click? x y)
                  (string-append "t0tx" (number->string x) "xy" (number->string y) "y")
                  (generate-move-2 force-move)))))))


(define (generate-move)
  (if (null? force-move)
      (generate-move-0)
      (case level
        ((1) (generate-move-0) )
        ((2) (generate-move-1 force-move) )
        ( else (generate-move-2 force-move)))))

(define (prepare-next-move x y)
  (cond ( (= level 1) (prepare-next-move-0) )
        ( (= level 2) (prepare-next-move-1 x y) )
        ( else (prepare-next-move-2 x y))))

(define (prepare-next-move-0)
  void)

(define (prepare-next-move-1 x y)
  (let ((right (cons (add1 x) y))(left (cons (sub1 x) y))
        (up (cons x (sub1 y)))(down (cons x (add1 y))))
    (case sens
      ((0) (set! force-move (cons right (cons up (cons left (cons down '()))))))
      ((1) (set! force-move (cons up (cons left (cons down (cons right '()))))))
      ((2) (set! force-move (cons left (cons down (cons right (cons up '()))))))
      ((3) (set! force-move (cons down (cons right (cons up (cons left '())))))))))

(define (prepare-next-move-2 x y)
  (cond ( (and (member (status? my-grid-vect (add1 x) y) '(type-1 type-2 type-3 type-4 type-5 checked))
               (> (status? coulee1 (add1 x) y) 0)
               (status? my-grid-vect (add1 x) y)) 
          (set! force-move (cons (cons (add1 x) y) (cons (cons (sub1 x) y) force-move))))
        ( (and (member (status? my-grid-vect (sub1 x) y) '(type-1 type-2 type-3 type-4 type-5 checked))
               (> (status? coulee1 (sub1 x) y) 0)
              (status? my-grid-vect (sub1 x) y)) 
          (set! force-move (cons (cons (add1 x) y) (cons (cons (sub1 x) y) force-move))))
        ( (and (member (status? my-grid-vect x (sub1 y)) '(type-1 type-2 type-3 type-4 type-5 checked))
               (> (status? coulee1 x (sub1 y)) 0)
               (status? my-grid-vect x (sub1 y))) 
          (set! force-move (cons (cons x (add1 y)) (cons (cons x (sub1 y)) force-move))))
        ( (and (member (status? my-grid-vect x (add1 y)) '(type-1 type-2 type-3 type-4 type-5 checked))
               (> (status? coulee1 x (add1 y)) 0)
               (status? my-grid-vect x (add1 y))) 
           (set! force-move (cons (cons x (add1 y)) (cons (cons x (sub1 y)) force-move))))))

(define (can-click? x y)
  (and (< x WIDTH) (< y HEIGHT) 
       (> x -1) (> y -1) 
       (not (eq? (status? my-grid-vect x y) 'checked))))

(define (reset)
  (set! my-grid-vect (build-vector WIDTH (lambda(i) (make-vector HEIGHT 'not-set))))
  (set! coulee (build-vector WIDTH (lambda(i) (make-vector HEIGHT 0))))
  (set! nb-posed 0)
  (set! nb-to-pose 1)
  (set! nb-posed-type (vector 0 0 0 0 0 0))
  (init my-pasteboard uncovered-is))

(define (home->away move)
  (let-values (((in out) (tcp-connect "membres.lycos.fr" 80)))
    (fprintf out (string-append "GET http://membres.lycos.fr/mit2k8/essai.php?cmd=set&move=" move " HTTP/1.0~n~n"))))

(define (force-away->home move)
  (let-values (((in out) (tcp-connect "membres.lycos.fr" 80)))
    (fprintf out (string-append "GET http://membres.lycos.fr/mit2k8/essai.php?cmd=set&move=" move " HTTP/1.0~n~n"))))

(define (played?)
    (let-values (((in out) (tcp-connect "membres.lycos.fr" 80)))
    (fprintf out (string-append "GET http://membres.lycos.fr/mit2k8/essai.php?cmd=flag HTTP/1.0~n~n"))    
    (let ((ret '?))
    (call-with-output-file "bidon.txt"
      (lambda (port)
        (do ((str (read-line in) (read-line in)))
          ((eof-object? str) (newline port))
          (if (regexp-match "[0-9]" str)
              (set! ret (car (regexp-match "[0-9]" str))))))
      'replace)
    ret)))

(define (loop-till-0 i)
  (if (= i 15)
      (begin
        (send message set-label "15 sec. delay over !!!")
        (end-of-time-greeting))
      (if (equal? (played?) "1")
          (begin
            (sleep 1)
            (loop-till-0 (add1 i)))
            (away->home))))

(define (loop-till-0)
      (if (equal? (played?) "1")
          (begin
            (sleep 1)
            (loop-till-0))
            (away->home)))

(define (loop-till-1 i)
  (if (= i 15)
      (begin
        (send message set-label "15 sec. delay over !!!")
        (end-of-time-greeting))
      (if (equal? (played?) "0")
          (begin
            (sleep 1)
            (loop-till-1 (add1 i) move))
          (away->home))))
 
(define (loop-till-1)
  
      (if (equal? (played?) "0")
          (begin
            (sleep 1)
            (loop-till-1))
          (away->home)))

(define (away->home)
  (let-values (((in out) (tcp-connect "membres.lycos.fr" 80)))
    (fprintf out (string-append "GET http://membres.lycos.fr/mit2k8/essai.php?cmd=show HTTP/1.0~n~n"))    
    (let ((ret '?))
    (call-with-output-file "bidon.txt"
      (lambda (port)
        (do ((str (read-line in) (read-line in)))
          ((eof-object? str) (newline port))
          (if (regexp-match "t[0-9f]+tx[0-9]+xy[0-9]+y" str)
              (set! ret (car (regexp-match "t[0-9f]+tx[0-9]+xy[0-9]+y" str))))))
      'replace)
    ret)))

(define (flag1!)
  (let-values (((in out) (tcp-connect "membres.lycos.fr" 80)))
    (fprintf out "GET http://membres.lycos.fr/mit2k8/essai.php?cmd=flag1 HTTP/1.0~n~n")))

(define (flag0!)
  (let-values (((in out) (tcp-connect "membres.lycos.fr" 80)))
    (fprintf out "GET http://membres.lycos.fr/mit2k8/essai.php?cmd=flag0 HTTP/1.0~n~n")))