(define my-pasteboard%
  (class pasteboard% ()
    (public
      (effect-move 
       (lambda (move)
                   (let* ((x (cadr move))(y (caddr move))
                         (s (send this find-snip (* x  IMG-SIZE) (* y IMG-SIZE))))
                     (if end-of-game?  
                         (end-of-game-greeting))
                     (if (eq? (status? my-grid-vect x y) 'empty)
                         (begin
                           (send s set-bitmap over-is)
                           (play-sound "splash.wav" #f)
                           (status! my-grid-vect x y 'checked))
                         (begin
                           (send s set-bitmap explosion-is)
                           (play-sound "boom.wav" #f)
                           (set! he-bombed (add1 he-bombed))
                           (set! last-forced? #t)                           
                           (prepare-next-move x y)                           
                           (if (not last-forced?)
                               (set! last-bomb (cons x y)))
                           (status! my-grid-vect x y 'checked)
                           (test-end-of-game)))))))
    (override 	  
      (on-default-event 	   
       (lambda (event)
	     (let* ((type (send event get-event-type))
		    (x (send event get-x))
                    (y (send event get-y))
                    (indice-x (inexact->exact (quotient x IMG-SIZE)))
		    (indice-y (inexact->exact (quotient y IMG-SIZE)))   
                    (s (send this find-snip x y)))
               (cond 
                 ((or (< indice-x 0) (> indice-x (sub1 WIDTH)) (< indice-y 0) 
                      (> indice-y (sub1 HEIGHT)) game-started?)
                  ())
                 ((eq? type 'right-down)
                  (if (can-pose? my-grid-vect indice-x indice-y nb-to-pose 'h)
                        (begin
                          (pose-and-show2! my-grid-vect indice-x indice-y nb-to-pose 'h)
                          (set! nb-posed (+ nb-posed nb-to-pose))
                          (vector-set! nb-posed-type nb-to-pose (add1 (vector-ref nb-posed-type nb-to-pose)))
                          (test-nb-posed))
                        (send message set-label "IMPOSSIBLE to pose Horiz!")))
                 ((eq? type 'left-down)
                  (if (can-pose? my-grid-vect indice-x indice-y nb-to-pose 'v)
                      (begin
                        (pose-and-show2! my-grid-vect indice-x indice-y nb-to-pose 'v)
                        (set! nb-posed (+ nb-posed nb-to-pose))
                        (vector-set! nb-posed-type nb-to-pose (add1 (vector-ref nb-posed-type nb-to-pose)))
                        (test-nb-posed))
                      (send message set-label "IMPOSSIBLE to pose Vertic!")))) ))))
    (sequence (super-init))))

(define my-pasteboard-net%
  (class pasteboard% ()
    (public
      (get-t
       (lambda ()
         (let ((s (send his-pasteboard find-snip 
                        (* IMG-SIZE (car last-move))(* IMG-SIZE (cadr last-move)))))
           (printf "entree get-t ~a~n" answer-t)
           (if (zero? answer-t)
             (begin
               (send s set-bitmap empty-is)
               (play-sound "splash.wav" #f))
             (begin
               (if show?
                   (case answer-t
                 ((1 6) (send s set-bitmap explosion-1-is))
                 ((2 7) (send s set-bitmap explosion-2-is))
                 ((3 8) (send s set-bitmap explosion-3-is))
                 ((4 9) (send s set-bitmap explosion-4-is))
                 ((5 10) (send s set-bitmap explosion-5-is)))
                   (send s set-bitmap explosion-is))
               (case (- answer-t 5)
                 ((1) (send message set-label "Ship Type 1 is Down"))
                 ((2) (send message set-label "Ship Type 2 is Down"))
                 ((3) (send message set-label "Ship Type 3 is Down"))
                 ((4) (send message set-label "Ship Type 4 is Down"))
                 ((5) (send message set-label "Ship Type 5 is Down")))
               (play-sound "boom.wav" #f)
               (set! i-bombed (add1 i-bombed))
               (test-end-of-game)))
           (printf "sortie get-t~n"))))
      (effect-answer-ret-t 
       (lambda (move)
                   (let* ((x (cadr move))(y (caddr move))
                         (s (send this find-snip (* x  IMG-SIZE) (* y IMG-SIZE))))
                     (printf "entree effect-answer move : ~a request-t : ~a~n" move request-t)
                     (if end-of-game?  
                         (end-of-game-greeting))
                     (if (eq? (status? my-grid-vect x y) 'empty)
                         (begin
                           (send s set-bitmap over-is)
                           (play-sound "splash.wav" #f)
                           (status! my-grid-vect x y 'checked)
                           (set! request-t 0))
                         (begin
                           (if show?
                           (case (status? my-grid-vect x y)
                             ((type-1) (send s set-bitmap explosion-1-is)(set! request-t 1))
                              ;(status! coulee x y (+ (status? coulee x y 5)))(a-ajouter x y 1))
                             ((type-2) (send s set-bitmap explosion-2-is)(set! request-t 2))
                              ;(status! coulee x y (+ (status? coulee x y 5)))(a-ajouter x y 2))
                             ((type-3) (send s set-bitmap explosion-3-is)(set! request-t 3))
                              ;(status! coulee x y (+ (status? coulee x y 5)))(a-ajouter x y 3))
                             ((type-4) (send s set-bitmap explosion-4-is)(set! request-t 4))
                              ;(status! coulee x y (+ (status? coulee x y 5)))(a-ajouter x y 4))
                             ((type-5) (send s set-bitmap explosion-5-is)(set! request-t 5)))
                              ;(status! coulee x y (+ (status? coulee x y 5)))(a-ajouter x y 5)))
                           (case (status? my-grid-vect x y)
                             ((type-1) (send s set-bitmap explosion-is)(set! request-t 1))
                              ;(status! coulee x y (+ (status? coulee x y 5)))(a-ajouter x y 1))
                             ((type-2) (send s set-bitmap explosion-is)(set! request-t 2))
                              ;(status! coulee x y (+ (status? coulee x y 5)))(a-ajouter x y 2))
                             ((type-3) (send s set-bitmap explosion-is)(set! request-t 3))
                              ;(status! coulee x y (+ (status? coulee x y 5)))(a-ajouter x y 3))
                             ((type-4) (send s set-bitmap explosion-is)(set! request-t 4))
                              ;(status! coulee x y (+ (status? coulee x y 5)))(a-ajouter x y 4))
                             ((type-5) (send s set-bitmap explosion-is)(set! request-t 5))))
                              ;(status! coulee x y (+ (status? coulee x y 5)))(a-ajouter x y 5))))
                           (play-sound "boom.wav" #f)
                           (set! he-bombed (add1 he-bombed))
                           (status! my-grid-vect x y 'checked)
                           (test-end-of-game)
                           (printf "sortie effect-answer request-t : ~a~n" request-t)))))))
    (override 	  
      (on-default-event 	   
       (lambda (event)
	     (let* ((type (send event get-event-type))
		    (x (send event get-x))
                    (y (send event get-y))
                    (indice-x (inexact->exact (quotient x IMG-SIZE)))
		    (indice-y (inexact->exact (quotient y IMG-SIZE)))   
                    (s (send this find-snip x y)))
               (cond 
                 ((or (< indice-x 0) (> indice-x (sub1 WIDTH)) (< indice-y 0) 
                      (> indice-y (sub1 HEIGHT)) game-started?)
                  ())
                 ((eq? type 'right-down)
                  (if (can-pose? my-grid-vect indice-x indice-y nb-to-pose 'h)
                        (begin
                          (pose-and-show! my-grid-vect indice-x indice-y nb-to-pose 'h)
                          (set! nb-posed (+ nb-posed nb-to-pose))
                          (vector-set! nb-posed-type nb-to-pose (add1 (vector-ref nb-posed-type nb-to-pose)))
                          (test-nb-posed))
                        (send message set-label "IMPOSSIBLE to pose Horiz!")))
                 ((eq? type 'left-down)
                  (if (can-pose? my-grid-vect indice-x indice-y nb-to-pose 'v)
                      (begin
                        (pose-and-show! my-grid-vect indice-x indice-y nb-to-pose 'v)
                        (set! nb-posed (+ nb-posed nb-to-pose))
                        (vector-set! nb-posed-type nb-to-pose (add1 (vector-ref nb-posed-type nb-to-pose)))
                        (test-nb-posed))
                      (send message set-label "IMPOSSIBLE to pose Vertic!")))) ))))
    (sequence (super-init))))